program getExternalIPCUI;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  Vcl.Forms,
  System.SysUtils, idhttp, IdSSLOpenSSL, IdSocks, Winapi.Windows, strutils;

var IdHttp:TIdHttp; s:String;
  IdSSLIOHandlerSocketOpenSSL:TIdSSLIOHandlerSocketOpenSSL;

function Between(s,sB,sE:String; els:string='0'; posit:PDWORD=nil):String;
var
  k1,k2:integer;
begin
  Result:=els;
  if posit=nil then
  k1:=PosEx(sB,s) else k1:=PosEx(sB,s,posit^);
  if k1=0 then exit;
  k1:=k1+length(sB);
  k2:=PosEx(sE,s,k1);
  if k2=0 then Exit;
  Result:=copy(s,k1,k2-k1);
  if posit<>nil then posit^:=k2;
end;

begin
  try
    //raise Exception.Create('Params count - 0');
    if ParamCount=1 then

    s:='';
    IdHttp:=TIdHttp.Create(nil);
    IdSSLIOHandlerSocketOpenSSL:=TIdSSLIOHandlerSocketOpenSSL.Create(idhttp);
    try
      IdHttp.ConnectTimeout:=10000;
      IdSSLIOHandlerSocketOpenSSL.SSLOptions.Method := sslvSSLv23;
      IdHTTP.IOHandler:=IdSSLIOHandlerSocketOpenSSL;
      s := IdHttp.Get('https://cmyip.com/');
      s := between(s, 'My IP Address is ', '<a','');
      s := Trim(s);
      writeln('externalIP:'+s);
    finally
      FreeAndNil(IdSSLIOHandlerSocketOpenSSL);
      FreeAndNil(IdHttp);
    end;
  except
    on E: Exception do
      Writeln('Error:'+E.ClassName, ': ', E.Message);
  end;
end.
