program getExternalIP;

uses
  Vcl.Forms,
  SysUtils,
  idhttp,
  IdSSLOpenSSL,
  IdSocks,
  Winapi.Windows,
  strutils,
  WMEXTENALIPUnit in 'WMEXTENALIPUnit.pas', Winapi.WinSock, Winapi.Messages;

{$R *.res}

var result:string;
  h:THandle;
  DataStruct: CopyDataStruct;
  localIP,externalIP:string;
  GInitData: TWSAData;

function Between(s,sB,sE:String; els:string='0'; posit:PDWORD=nil):String;
var
  k1,k2:integer;
begin
  Result:=els;
  if posit=nil then
  k1:=PosEx(sB,s) else k1:=PosEx(sB,s,posit^);
  if k1=0 then exit;
  k1:=k1+length(sB);
  k2:=PosEx(sE,s,k1);
  if k2=0 then Exit;
  Result:=copy(s,k1,k2-k1);
  if posit<>nil then posit^:=k2;
end;

function getExternalIPFunc:string;
var IdHttp:TIdHttp; s:String;
  IdSSLIOHandlerSocketOpenSSL:TIdSSLIOHandlerSocketOpenSSL;
begin
try
  s:='';
  IdHttp:=TIdHttp.Create(nil);
  IdSSLIOHandlerSocketOpenSSL:=TIdSSLIOHandlerSocketOpenSSL.Create(idhttp);
  try
    IdHttp.ConnectTimeout:=10000;
    IdSSLIOHandlerSocketOpenSSL.SSLOptions.Method := sslvSSLv23;
    IdHTTP.IOHandler:=IdSSLIOHandlerSocketOpenSSL;
    s := IdHttp.Get('https://cmyip.com/');
    s := between(s, 'My IP Address is ', '<a','');
    s := Trim(s);
    exit(s);
  finally
    FreeAndNil(IdSSLIOHandlerSocketOpenSSL);
    FreeAndNil(IdHttp);
  end;
except
  on E:Exception do
    exit('Error:'+E.ClassName+':'+E.Message);
end;
end;

begin
  try
    result:=getExternalIPFunc;
    //raise Exception.Create('Params count - 0');
    if ParamCount=0 then begin
      AllocConsole;
      try
        Writeln(result);
        Readln;
      finally
        FreeConsole
      end;
      exit;
    end else begin
      h:=StrToInt64(ParamStr(1));
      localIP:='127.0.0.1';
      if paramCount>1 then localIP:=ParamStr(2);
      //SendMessage(h, WM_EXTENALIP, 0, LPARAM(PChar(result)));
//      DataStruct.dwData:= 0;
//      DataStruct.cbData:=length(result)+1;
//      DataStruct.lpData:=pchar(result);
//      SendMessage(h,WM_CopyData, 0, lParam(@DataStruct));
      WSAStartup($101, GInitData);
      if result.StartsWith('Error:') or (result='') then begin
        result:='127.0.0.1';
      end;
      SendMessage(h, WM_EXTENALIP, wparam(inet_addr(PAnsiChar(AnsiString(localIP)))),
        LPARAM(inet_addr(PAnsiChar(AnsiString(result)))));
      WSACleanup;
    end;
  except
//    on E: Exception do
//      Writeln('Error:'+E.ClassName, ': ', E.Message);
  end;

  //Application.Initialize;
  //Application.MainFormOnTaskbar := True;
  //Application.Run;
end.
